package Controllers.DevisClt;

import Controllers.Traitement.MyWindow;
import Models.DevisClt.DevisCltListe;
import Models.DevisClt.DevisDB;
import javafx.scene.control.ProgressBar;
import java.io.IOException;
import java.net.URL;
import java.util.ResourceBundle;
import org.apache.log4j.Logger;
import javafx.beans.value.ChangeListener;
import javafx.beans.value.ObservableValue;
import javafx.collections.FXCollections;
import javafx.collections.ObservableList;
import javafx.concurrent.Service;
import javafx.concurrent.Task;
import javafx.concurrent.WorkerStateEvent;
import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import javafx.fxml.FXML;
import javafx.fxml.FXMLLoader;
import javafx.fxml.Initializable;
import javafx.scene.Group;
import javafx.scene.Node;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.control.ChoiceBox;
import javafx.scene.control.DatePicker;
import javafx.scene.control.Label;
import javafx.scene.control.RadioButton;
import javafx.scene.control.TableColumn;
import javafx.scene.control.TableView;
import javafx.scene.control.TextField;
import javafx.scene.control.cell.PropertyValueFactory;
import javafx.scene.input.KeyCode;
import javafx.scene.input.KeyEvent;
import javafx.scene.input.MouseEvent;
import javafx.scene.layout.AnchorPane;
import javafx.scene.layout.StackPane;
import javafx.scene.text.Text;
import javafx.stage.Stage;


/**
 * FXML Controller class
 * @author Maher Ben Tili
 */
public class DevisImporterController implements Initializable {

    Logger logger = Logger.getLogger(DevisImporterController.class.getName());
    
    @FXML private AnchorPane anchorpane ;
    
    @FXML private ProgressBar ProgressBarDevisClt;
    
    @FXML private Button ButtonSearchDevisClt;
    
    @FXML public TableView<DevisCltListe> TableViewGestionDevis;
    
    @FXML public TableColumn<DevisCltListe ,String> TabColCodeDevis;
    @FXML public TableColumn<DevisCltListe ,String> TabColModePaiement;
    @FXML public TableColumn<DevisCltListe ,String> TabColTypeClient;
    @FXML public TableColumn<DevisCltListe ,String> TabColCodeClient;
    @FXML public TableColumn<DevisCltListe ,String> TabColTotalDevis;
    @FXML public TableColumn<DevisCltListe ,String> TabColDateCreation ;
    @FXML public TableColumn<DevisCltListe ,String> TabColDateFinValidite;
    @FXML public TableColumn<DevisCltListe ,Boolean>TabColDetail ;
    
    @FXML public TextField TextFieldCodeDevis ;
    @FXML public TextField TextFieldCodeClient ;
    @FXML public DatePicker DatePickerCreation ;
    @FXML public TextField TextFieldNomPrenomClient ;
    @FXML public TextField TextFieldCinClient;
    @FXML public RadioButton RadioComptant;
    @FXML public RadioButton RadioFacilite;
    
    @FXML private Text ActuellePage ;
    @FXML private Text NbrPage ;
    @FXML private Group nextgroupe ;
    @FXML private Group avancergroupe ;
    @FXML private Group lastgroupe ;        
    @FXML private Group retourgroupe ;
    @FXML private Label LabelCount ;
    @FXML private ChoiceBox NbrLigne ;
    
    ObservableList cursors = FXCollections.observableArrayList("10","15","20");
    private Integer nbrligne = 10 ;
    private Integer totalcount = 0;
    private Integer nbrpage = 0;
    private Integer actuellepage = 1;
    Integer position = 0;
    
    public Node node;
    
    private Service<Void> ThreadSearchDevisCltRechercher;
    
    public DevisImporterController() {
        try {
            FXMLLoader fxmlLoader = new FXMLLoader(getClass().getResource("/Views/Devis/DevisImporter.fxml"));
            fxmlLoader.setController(this);
            node = (Node) fxmlLoader.load();
        } catch (IOException ex) {
            logger.error("DevisImporterController  : DevisImporter.fxml :" + ex.getMessage());
        }
    }
    
    
    
    public void Show()
    {
        StackPane Sp = new StackPane();
            
        Scene scene = new Scene(Sp);
        
        Sp.setPrefSize((double)MyWindow.PrincipalContentWidth, (double)MyWindow.PrincipalContentHeight);
       
        Sp.getChildren().add(MyWindow.myParent);
        Sp.getChildren().add(node);
        
        Stage stage = MyWindow.myStage;
        stage.setScene(scene);
        stage.show();
    }
    
    
    @Override
    public void initialize(URL url, ResourceBundle rb) {
       
        //comboboxnombre des lignes tableview
        NbrLigne.setItems(cursors);
        NbrLigne.getSelectionModel().selectFirst();
        
        TableViewGestionDevis.setEditable(true);
        
        TabColCodeDevis.setStyle( "-fx-alignment: CENTER;");TabColCodeDevis.getStyleClass().add("Center");
        TabColCodeDevis.setCellValueFactory(new PropertyValueFactory<DevisCltListe, String>("CodeDevis"));
        
        TabColTypeClient.setStyle( "-fx-alignment: CENTER;");TabColTypeClient.getStyleClass().add("Center");
        TabColTypeClient.setCellValueFactory(new PropertyValueFactory<DevisCltListe, String>("TypeClient"));
        
        TabColCodeClient.setStyle( "-fx-alignment: CENTER;");TabColCodeClient.getStyleClass().add("Center");
        TabColCodeClient.setCellValueFactory(new PropertyValueFactory<DevisCltListe, String>("CodeClient"));
        
        TabColModePaiement.setStyle( "-fx-alignment: CENTER;");TabColModePaiement.getStyleClass().add("Center");
        TabColModePaiement.setCellValueFactory(new PropertyValueFactory<DevisCltListe, String>("ModePaiement"));
        
        TabColTotalDevis.setStyle( "-fx-alignment: CENTER;");TabColTotalDevis.getStyleClass().add("Center");
        TabColTotalDevis.setCellValueFactory(new PropertyValueFactory<DevisCltListe, String>("TotalDevis"));
        
        TabColDateCreation.setStyle( "-fx-alignment: CENTER;");TabColDateCreation.getStyleClass().add("Center");
        TabColDateCreation.setCellValueFactory(new PropertyValueFactory<DevisCltListe, String>("DateCreation"));
        
        TabColDateFinValidite.setStyle( "-fx-alignment: CENTER;");TabColDateFinValidite.getStyleClass().add("Center");
        TabColDateFinValidite.setCellValueFactory(new PropertyValueFactory<DevisCltListe, String>("FinValidite"));
        
        TabColDetail.setSortable(true);
        TabColDetail.setStyle( "-fx-alignment: CENTER;");TabColDetail.getStyleClass().add("Center");
        
        ButtonSearchDevisClt.setOnMouseClicked(new EventHandler<MouseEvent>() {
            public void handle(MouseEvent me) {
                SearchDevisClt();
            }
        });
        
        anchorpane.setOnKeyPressed(new EventHandler<KeyEvent>() {
            @Override
            public void handle(KeyEvent ke) {
                if (ke.getCode().equals(KeyCode.ENTER)) {
                    SearchDevisClt();
                }
            }
        });
        
        GestionSearchDevisClt();
    }   
    
    @FXML
    private void QuiterButtonAction(ActionEvent event) throws IOException {
        anchorpane.setVisible(false);
    }
    
    
    
    
/******************************************************************************                                                                             *
 *                                                                              *
 *                       Methode last Next TableView                        *
 * *                                                                            *
 ******************************************************************************/  
 
    private void SearchDevisClt()
    {
        ProgressBarDevisClt.setVisible(true);
        
        ButtonSearchDevisClt.setDisable(true);
        
        ThreadSearchDevisCltRechercher = new Service<Void>(){
            @Override
            protected Task<Void> createTask(){
                return new Task<Void>(){
                    @Override
                    protected Void call() throws Exception{
                        
                        position = 0;
                        
                        actuellepage = 1;
                        
                        String DateCreation = "";
                        if(DatePickerCreation.getValue() != null){
                            DateCreation = DatePickerCreation.getValue().toString();
                        }    
                        
                        //     0comptant        1facilité
                        String TypeRegement = "";
                        if(RadioComptant.isSelected()){
                            TypeRegement = "0";
                        }else if(RadioFacilite.isSelected()){
                            TypeRegement = "1";
                        }
                        
                        ObservableList<DevisCltListe> ListDevisClts = new DevisDB().SearchDevisCltGestion(
                                                                                        position, 
                                                                                        nbrligne, 
                                                                                        TextFieldCodeDevis.getText(),  
                                                                                        TextFieldCodeClient.getText(), 
                                                                                        TypeRegement,  
                                                                                        DateCreation, 
                                                                                        TextFieldNomPrenomClient.getText(), 
                                                                                        TextFieldCinClient.getText());
                            
                        TableViewGestionDevis.setItems(ListDevisClts);
                        
                        totalcount = new DevisDB().nbrDevisCltGestion(TextFieldCodeDevis.getText(),  TextFieldCodeClient.getText(), TypeRegement,  DateCreation, TextFieldNomPrenomClient.getText(), TextFieldCinClient.getText());
                        
                        if(totalcount > 0){
                            ActuellePage.setText("1");
                        }else{
                            ActuellePage.setText("0");
                        }
                        
                        if(totalcount % nbrligne==0){ 
                            nbrpage = totalcount / nbrligne ;
                        }
                        else{ 
                            nbrpage = (totalcount / nbrligne) + 1 ; 
                        }
                        NbrPage.setText(Integer.toString(nbrpage));
                        
                        return null;
                    }
                };
            }
	};
        
        ThreadSearchDevisCltRechercher.setOnSucceeded(new EventHandler<WorkerStateEvent>(){
            @Override
            public void handle(WorkerStateEvent event){
                ProgressBarDevisClt.setVisible(false);
                ButtonSearchDevisClt.setDisable(false);
                LabelCount.setText(totalcount.toString());
                
            }
        });
        ThreadSearchDevisCltRechercher.start();
    }
    
    
    private void NextLastSearchDevisClt(Integer ParmPosition, Integer ParamNbrligne)
    {
        ProgressBarDevisClt.setVisible(true);
        
        ButtonSearchDevisClt.setDisable(true);
        
        ThreadSearchDevisCltRechercher = new Service<Void>(){
            @Override
            protected Task<Void> createTask(){
                return new Task<Void>(){
                    @Override
                    protected Void call() throws Exception{
                        
                        String DateCreation = "";
                        if(DatePickerCreation.getValue() != null){
                            DateCreation = DatePickerCreation.getValue().toString();
                        }    
                        
                        //     0comptant        1facilité
                        String TypeRegement = "";
                        if(RadioComptant.isSelected()){
                            TypeRegement = "0";
                        }else if(RadioFacilite.isSelected()){
                            TypeRegement = "1";
                        }
                        
                        ObservableList<DevisCltListe> ListDevisClts = new DevisDB().SearchDevisCltGestion(ParmPosition, ParamNbrligne, TextFieldCodeDevis.getText(),  TextFieldCodeClient.getText(), TypeRegement,  DateCreation, TextFieldNomPrenomClient.getText(), TextFieldCinClient.getText());
                        
                        TableViewGestionDevis.setItems(ListDevisClts);
                        
                        return null;
                    }
                };
            }
	};
        
        ThreadSearchDevisCltRechercher.setOnSucceeded(new EventHandler<WorkerStateEvent>(){
            @Override
            public void handle(WorkerStateEvent event){
                ProgressBarDevisClt.setVisible(false);
                ButtonSearchDevisClt.setDisable(false);
            }
        });
        ThreadSearchDevisCltRechercher.start();
    }
  
    private void GestionSearchDevisClt()
    {
        NbrLigne.getSelectionModel().selectedIndexProperty().addListener(new ChangeListener<Number>() {

            public void changed(ObservableValue ov,  Number value, Number new_value) {
                nbrligne= Integer.parseInt((String) cursors.get(new_value.intValue()));
                if(totalcount % nbrligne==0){ nbrpage = totalcount / nbrligne ;}
                else{ nbrpage = (totalcount / nbrligne) + 1 ; }
                NbrPage.setText(Integer.toString(nbrpage));
                position=0;
                ActuellePage.setText("1");
                actuellepage=1;
                NextLastSearchDevisClt(position, nbrligne);
            }
        });

        if(totalcount % nbrligne==0){ nbrpage = totalcount / nbrligne ;}
        else{ nbrpage = (totalcount / nbrligne) + 1 ; }
        NbrPage.setText(Integer.toString(nbrpage));


        //next page
        nextgroupe.setOnMousePressed(new EventHandler<MouseEvent>(){
            @Override
            public void handle(MouseEvent event) {
                if(actuellepage<nbrpage)
                {
                    position=position+nbrligne;
                    NextLastSearchDevisClt(position, nbrligne);
                    actuellepage=actuellepage+1 ;
                    ActuellePage.setText(Integer.toString(actuellepage));

                }
            }
        }); 

        //last page
        lastgroupe.setOnMousePressed(new EventHandler<MouseEvent>(){
            @Override
            public void handle(MouseEvent event) {
                if(actuellepage>1)
                {
                    position=position-nbrligne;
                    NextLastSearchDevisClt(position, nbrligne);
                    actuellepage=actuellepage-1 ;
                    ActuellePage.setText(Integer.toString(actuellepage));
                }
            }
        }); 

        //next page avec pas de 5
        avancergroupe.setOnMousePressed(new EventHandler<MouseEvent>(){
            @Override
            public void handle(MouseEvent event) {
                if(actuellepage+3<nbrpage)
                {
                    position=(position+4)+nbrligne;
                    NextLastSearchDevisClt(position, nbrligne);
                    actuellepage=actuellepage+3 ;
                    ActuellePage.setText(Integer.toString(actuellepage));

                }
            }
        });

        //last page avec un pas de -5
        retourgroupe.setOnMousePressed(new EventHandler<MouseEvent>(){
            @Override
            public void handle(MouseEvent event) {
                if(actuellepage-3>1){
                    position=(position-4)-nbrligne;
                    NextLastSearchDevisClt(position, nbrligne);
                    actuellepage=actuellepage-3 ;
                    ActuellePage.setText(Integer.toString(actuellepage));
                }
            }
        });

    }
    
    
    
    
}
